package java.awt.image.renderable;

import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.RenderingHints;

public class RenderContext implements Cloneable
{
    RenderingHints hints;
    AffineTransform usr2dev;
    Shape aoi;
    
    public RenderContext(AffineTransform affineTransform, Shape aoi, RenderingHints hints) {
        this.hints = hints;
        this.aoi = aoi;
        this.usr2dev = (AffineTransform)affineTransform.clone();
    }
    
    public RenderContext(AffineTransform affineTransform) {
        this(affineTransform, null, null);
    }
    
    public RenderContext(AffineTransform affineTransform, RenderingHints renderingHints) {
        this(affineTransform, null, renderingHints);
    }
    
    public RenderContext(AffineTransform affineTransform, Shape shape) {
        this(affineTransform, shape, null);
    }
    
    public RenderingHints getRenderingHints() {
        return this.hints;
    }
    
    public void setRenderingHints(RenderingHints hints) {
        this.hints = hints;
    }
    
    public void setTransform(AffineTransform affineTransform) {
        this.usr2dev = (AffineTransform)affineTransform.clone();
    }
    
    public void preConcatenateTransform(AffineTransform affineTransform) {
        this.preConcetenateTransform(affineTransform);
    }
    
    @Deprecated
    public void preConcetenateTransform(AffineTransform tx) {
        this.usr2dev.preConcatenate(tx);
    }
    
    public void concatenateTransform(AffineTransform affineTransform) {
        this.concetenateTransform(affineTransform);
    }
    
    @Deprecated
    public void concetenateTransform(AffineTransform tx) {
        this.usr2dev.concatenate(tx);
    }
    
    public AffineTransform getTransform() {
        return (AffineTransform)this.usr2dev.clone();
    }
    
    public void setAreaOfInterest(Shape aoi) {
        this.aoi = aoi;
    }
    
    public Shape getAreaOfInterest() {
        return this.aoi;
    }
    
    public Object clone() {
        return new RenderContext(this.usr2dev, this.aoi, this.hints);
    }
}
